//<![CDATA[
if (!Date.now) {
    Date.now = function() { return new Date().getTime(); };
}

var CLIMATE_STEPS = 10;
var form_submit_choice = "";

function addEvent(element, evnt, funct){
  if (element.attachEvent)
   return element.attachEvent('on'+evnt, funct);
  else
   return element.addEventListener(evnt, funct, false);
}

function addRow(tableID) {

  var table = document.getElementById(tableID);

  var rowCount = table.rows.length;
  var row = table.insertRow(rowCount);

  var cell = row.insertCell(0);
  cell.innerHTML = rowCount;

  cell = row.insertCell(1);
  var element = document.createElement("input");
  element.type = "text";
  element.name="climate_settings__temperature__index"+ (rowCount - 1);
  cell.appendChild(element);

  cell = row.insertCell(2);
  element = document.createElement("input");
  element.type = "text";
  element.name="climate_settings__time__index"+ (rowCount - 1);
  cell.appendChild(element);
}

function makeTempTimeTable(tableID) {
  for (var i = 0; i < CLIMATE_STEPS; ++i) {
    addRow(tableID);
  }
}

function addOptions(select) {
  for (var i = 0; i <= 10; ++i) {
    var option = new Option (i, i);
    select.add(option);
  }
}

function onContactChange(target) {
  var hiddenContact = document.getElementById("ContactContact");
  var caller = target.target;
  if (caller == null)
    caller = target.srcElement;
  var key = caller.options[caller.selectedIndex].value;
  if (contacts.hasOwnProperty(key)) {
    hiddenContact.value = contacts[key];
  }
}

function onPresettingChange(target) {
  var caller = target.target;
  if (caller == null)
    caller = target.srcElement;
  var key = caller.options[caller.selectedIndex].value;
  if (presettings.hasOwnProperty(key)) {
    Preset.publicStaticClearFormValues("-", document.forms["climate_settings"], CLIMATE_STEPS);
    presettings[key].publicFillFormValues(key, document.forms["climate_settings"]);
  }
}

function optionizeOptions(elementID, sourceValuesArray, targetFunction) {
  var selectList = document.getElementById(elementID);
  if (selectList == null)
    return;
  //Create and append the options
  for (var key in sourceValuesArray) {
    if (sourceValuesArray.hasOwnProperty(key)) {
      var option = new Option (key, key);
      selectList.add(option);
    }
  }
  //selectList.onchange=OnCategoryChange(selectList);
  addEvent(
    selectList,
    'change',
    function(target) {targetFunction(target);}
  );
}

function packInfo() {
  if (form_submit_choice.length > 0) {
    var submit_info = document.getElementById("control");
    submit_info.value = form_submit_choice;
    return true;
  }
  return false;
}

function SetSelectedOption(id_source, id_destination) {
  var foundOption = false;

  var selected = document.getElementById(id_source);
  var selectList = document.getElementById(id_destination);
  if (selectList == null || selected == null)
    return;
  var source_text = selected.value;
  // try to select an existing option
  for (var key in selectList.options) {
    if (selectList.options.hasOwnProperty(key)) {
      if (selectList.options[key].text == source_text) {
        selectList.options[key].selected = true;
        foundOption = true;
        break;
      }
    }
  }
  if (!foundOption) {
    var option = new Option (source_text, source_text);
    selectList.add(option);
    selectList.selectedIndex = selectList.options.length - 1;
  }
}

function currentInfoString(infofield, xmlnode) {
  var cycle = xmlnode.getElementsByTagName("cycle_values");
  if (cycle != null) {
    var running = false;
    var state = 0;
    // state and mode
    var element = cycle[0].getElementsByTagName("active");
    if (element != null) {
      var infoelement = document.createElement("div");
      if (myTextContent(element[0]) == "1") {
        running = true;
        infoelement.innerHTML = "AKTIV";
      } else
        infoelement.innerHTML = "DEAKTIV";
      infofield.appendChild(infoelement);
    }
    element = cycle[0].getElementsByTagName("state");
    if (element != null) {
      state = parseInt(myTextContent(element[0]));
      switch (state) {
        default :
        case 0:
          infoelement.innerHTML += " und ruhig";
          infofield.style.backgroundImage = "none";
          break;
        case 1:
          infoelement.innerHTML += " und heizt";
          infofield.style.backgroundImage = "url(./warm.jpg)";
          break;
        case 2:
          infoelement.innerHTML += " und khlt";
          infofield.style.backgroundImage = "url(./cold.jpg)";
          break;
      }
    }
    element = cycle[0].getElementsByTagName("mode");
    if (element != null) {
      switch (parseInt(myTextContent(element[0]))) {
        default :
        case 0:
          infoelement.innerHTML += " ohne Aufgabe";
          break;
        case 1:
          infoelement.innerHTML += " aufwrts";
          break;
        case 2:
          infoelement.innerHTML += " runter";
          break;
        case 3:
          infoelement.innerHTML += " auf gleiche Temperatur";
          break;
      }
    }
    // description
    if (running) {
      element = cycle[0].getElementsByTagName("duration");
      if (element != null) {
        infoelement = document.createElement("div");
        infoelement.innerHTML = "Seit "+ myTextContent(element[0]) +" Minuten ";
        infofield.appendChild(infoelement);
      }
      element = cycle[0].getElementsByTagName("step");
      if (element != null) {
        infoelement.innerHTML += " auf Stufe "+ myTextContent(element[0]);
      }
      element = cycle[0].getElementsByTagName("cycle");
      if (element != null) {
        var parsed = parseInt(myTextContent(element[0]));
        infoelement.innerHTML += " im "+ (parsed + 1) +". Durchlauf";
      }
      // last status text
      element = cycle[0].getElementsByTagName("text");
      if (element != null) {
        infoelement = document.createElement("div");
        infoelement.innerHTML = "Letzte Meldung: "+ myTextContent(element[0]);
        infofield.appendChild(infoelement);
      }
    }
  }
}

function currentInfoData(infofield, xmlnode) {
  var stationID = "";
  var stationName = "";
  var timestamp = "";
  var channels, channel;
  var infoelement;
  var values = xmlnode.getElementsByTagName("avs");
  if (values == null)
    return false;
  values = values[0].getElementsByTagName("av");
  if (values == null)
    return false;

  for (var key in values) {
    if (values.hasOwnProperty(key) && (key != "length")) {
      stationID = values[key].getAttribute("si");
      stationName = values[key].getAttribute("sn");
      timestamp = values[key].getAttribute("ts");

      infoelement = document.createElement("div");
      infoelement.innerHTML = "Station "+ stationID;
      if (stationName != null && stationName.length > 0) {
        infoelement.innerHTML += " ("+ stationName +")";
      }
      infoelement.innerHTML += " um "+ timestamp;
      infofield.appendChild(infoelement);

      channels = values[key].getElementsByTagName("c");
      if (channels != null) {
        channel = channels[0].getElementsByTagName("v");
        if (channel != null) {
          for (var measuring in channel) {
            if (channel.hasOwnProperty(measuring) && (measuring != "length")) {
              var cName = channel[measuring].getAttribute("cn");
              var cUnit = channel[measuring].getAttribute("cu");
              var cValue = channel[measuring].getAttribute("cv");
              
              infoelement = document.createElement("div");
              infoelement.innerHTML = cName +" = "+ cValue +" "+ cUnit;
              infofield.appendChild(infoelement);
            }
          }
        }
      }
    }
  }
}

function fillCurrentInfo(server_address) {
  var xml = loadXML("GET", server_address +"/centipede?get=actual&_="+ Date.now());
  if (xml == null)
    return;

  xml = parseXML(xml);
  var actual = xml.getElementsByTagName("climate_control");
  var infofield = document.getElementById("climate_current");
  if ((infofield != null) && (actual != null)) {
    currentInfoString(infofield, actual[0]);
    currentInfoData(infofield, actual[0]);
  }
}

function fillSvg(server_address, svg_element) {
  var xhr = getXmlHttpRequest();
  xhr.open("GET", server_address +"/output/output.svg", false);
  // Following line is just to be on the safe side;
  // not needed if your server delivers SVG with correct MIME type
  if (xhr.overrideMimeType) xhr.overrideMimeType("image/svg+xml");
  xhr.send("");
  if (xhr.status > 300)
    throw "Status "+ xhr.status;
  svg_element.appendChild(xhr.responseXML.documentElement);
}


function climateOnLoad() {
  makeTempTimeTable("TempTimeTable");
  addOptions(document.getElementById("CycleRounds"));
  optionizeOptions("ContactName", contacts, onContactChange);
  optionizeOptions("Presettings", presettings, onPresettingChange);

  var parser = document.createElement('a');
  parser.href = window.location.href;
  baseUri = parser.protocol +"//"+ parser.hostname;
  
  try {
    fillClimateSettings(baseUri, "climate_settings");
  } catch (err) {
    //possibly no correct answer ...
  }
  if (document.climate_settings.active.value == "1") {
    document.getElementById("start").style.display = "none";
  } else {
    document.getElementById("stop").style.display = "none";
  }
  SetSelectedOption("hidden_preset", "Presettings");

  if (document.climate_settings.active.value == "1") {
    var button = document.getElementsByClassName("information_stop");
    button[0].style.display = "none";
  } else {
    var button = document.getElementsByClassName("information_run");
    button[0].style.display = "none";
  }
  button = document.getElementById("information_button");
  button.style.display = "inline";

  try {
    fillCurrentInfo(baseUri);
  } catch (err) {
    //possibly no correct answer ...
    var infofield = document.getElementById("climate_current");
    if (infofield) {
      var infoelement = document.createElement("div");
      infoelement.innerHTML = "nicht erreichbar";
      infofield.appendChild(infoelement);
    }
  }
  
  var svgfield = document.getElementById("svgContainer");
  if (svgfield) {
    var infoelement = document.createElement("a");
    infoelement.href = baseUri +"/output/output.svg";
    infoelement.name = "Kurvengrafik";
    try {
      fillSvg(baseUri, svgfield);
      var spanelement = document.createElement("span");
      spanelement.className = "link-spanner";
      infoelement.appendChild(spanelement);
    } catch (err) {
      //possibly no correct answer ...
      infoelement.innerHTML = "Kurvengrafik";
    }
    svgfield.appendChild(infoelement);
  }
}

//]]>
