//<![CDATA[
function myTextContent(contentNode) {
  if (contentNode.innerText != undefined)
    return contentNode.innerText;
  if (contentNode.text != undefined)
    return contentNode.text;
  return contentNode.textContent;
}

function myChildNodeCount(contentNode) {
  if (true) {
    childNodes = contentNode.childNodes;
    if (childNodes != null)
      return childNodes.length;
    else
      return 0;
  }
  return contentNode.childElementCount;
}

function makeSvg_conf(svg_conf, form_values, baseName) {
  var params = svg_conf.split('&');
  var paramName;
  
  for (var i = 0; i < 15; i++) {
    paramName = '';
    switch (i) {
      case 0 :
        paramName = 'ch1';
        break;
      case 1 :
        paramName = 'ch2';
        break;
      case 2 :
        paramName = 'ch3';
        break;
      case 5 :
        paramName = 'min';
        break;
      case 6 :
        paramName = 'max';
        break;
      case 7 :
        paramName = 'ticks';
        break;
      case 8 :
        paramName = 'hours';
        break;
      case 9 :
        paramName = 'colour1';
        break;
      case 10 :
        paramName = 'colour2';
        break;
      case 11 :
        paramName = 'colour3';
        break;
      case 12 :
        paramName = 'fill1';
        break;
      case 13 :
        paramName = 'fill2';
        break;
      case 14 :
        paramName = 'fill3';
        break;
    }
    
    node = form_values.elements[baseName + '__' + paramName];
    if (node != null)
      node.value = params[i];
  }
}

function treeTraverse(tree, form_values, positionName) {
  if (tree == null)
    return;
  var childNodes = tree.childNodes;
  for (var i = 0; i < childNodes.length; i++) {
    presentTag = childNodes[i].tagName;
    if (presentTag == null)
      continue;
    completeName = positionName + "__" + presentTag;
    if (presentTag.indexOf("index") >= 0) {
      treeTraverse(childNodes[i], form_values, completeName);
    } else {
      node = form_values.elements[completeName];
      if (node != null) {
        node.value = myTextContent(childNodes[i]);
      } else if (presentTag == "svg_conf") {
        // pick params from string
        makeSvg_conf(myTextContent(childNodes[i]), form_values, completeName);
      }

      if (myChildNodeCount(childNodes[i]) > 0) {
        treeTraverse(childNodes[i], form_values, completeName);
      }
    }
  }
}

function fillSettings(subsetting) {
  var xml = loadXML("GET", "/viper?settings" + "=" + new Date().getTime());
  if (xml == null)
    return;

  xml = parseXML(xml);
  var form_settings = xml.getElementsByTagName(subsetting);
  var form_values = document.forms[subsetting];

  if ((form_settings != null) && (form_values != null))
    treeTraverse(form_settings[0], form_values, subsetting);
}
//]]>
